--- old/usr/src/uts/armv6/loader/fakeloader.c	2015-02-12 20:33:26.847141503 -0500
+++ new/usr/src/uts/armv6/loader/fakeloader.c	2015-02-12 20:33:26.854513252 -0500
@@ -35,7 +35,7 @@
  *   		- boot_archive
  *   		- atags
  *   o Enable unaligned access
- *   o Enable the caches + virtual memory
+ *   o Enable virtual memory
  *
  * There are several important constraints that we have here:
  *
@@ -703,10 +703,6 @@
 
 	FAKELOAD_DPRINTF("why helo thar\n");
 
-	/* Renable caches */
-	armv6_dcache_enable();
-	armv6_icache_enable();
-
 	/* we should never come back */
 	fakeload_exec(ident, ident2, chain, unix_start);
 	fakeload_panic("hit the end of the world\n");
--- old/usr/src/uts/armv6/ml/glocore.s	2015-02-12 20:33:27.075638250 -0500
+++ new/usr/src/uts/armv6/ml/glocore.s	2015-02-12 20:33:27.083010910 -0500
@@ -42,7 +42,7 @@
  *   - a UART has been enabled & any memory mapped registers have been 1:1
  *     mapped
  *   - ATAGs have been updated to tell us what the mappings are
- * - I/D L1 caches have been enabled
+ * - I/D L1 caches have may be disabled
  */
 
 	/*
@@ -89,6 +89,20 @@
 	orr	r3, r3, #(1 << 13)
 	mcr	p15, 0, r3, c1, c0, 0
 
+	/*
+	 * Go ahead now and enable the L1 I/D caches.  (Involves
+	 * invalidating the caches and the TLB.)
+	 */
+	mov	r4, #0
+	mov	r5, #0
+	mcr	p15, 0, r4, c7, c7, 0	/* invalidate caches */
+	mcr	p15, 0, r4, c8, c7, 0	/* invalidate tlb */
+	mcr	p15, 0, r5, c7, c10, 4	/* DSB */
+	mrc	p15, 0, r4, c1, c0, 0
+	orr	r4, #0x04	/* D-cache */
+	orr	r4, #0x1000	/* I-cache */
+	mcr	p15, 0, r4, c1, c0, 0
+
 	/* invoke machine specific setup */
 	bl	_mach_start
 
@@ -111,7 +125,6 @@
 	 * then main. We're never going back so we shouldn't feel compelled to
 	 * preserve any registers.
 	 *
-	 *  o Enable our I/D-caches
 	 *  o Save the boot syscalls and bootops for later
 	 *  o Set up our stack to be the real stack of t0stack.
 	 *  o Save t0 as curthread
@@ -162,14 +175,6 @@
 	mcr	p15, 0, r0, c13, c0, 4
 
 	/*
-	 * Go ahead now and enable the L1 I/D caches.  
-	 */
-	mrc	p15, 0, r0, c1, c0, 0
-	orr	r0, #0x04	/* D-cache */
-	orr	r0, #0x1000	/* I-cache */
-	mcr	p15, 0, r0, c1, c0, 0
-
-	/*
 	 * mlsetup() takes the struct regs as an argument. main doesn't take
 	 * any and should never return. Currently, we have an 8-byte aligned
 	 * stack.  We want to push a zero frame pointer to terminate any
